(********************************************************************)
(*																	*)
(*					ARPG Editor (GUI Version)						*)
(*																	*)
(********************************************************************)

uses GuiMain,TClass,GuiMap,GuiObj,GuiMenu,Graph,Video;

var	GD:PGuiDisplay;
	pEdit:PEditBox;
	x,y,Action:Integer;
	Room:TRoom;
	s:String;

begin
	x := 1;
	if ParamCount = 1 then
		begin
			Val(ParamStr(1),x,y);
			if y <> 0 then x := 0;
		end;
	if (x < 1) or (x > 255) then
		begin
			WriteLn('AE <Room Number>');
			WriteLn('        ADK Room Editor Program. Written by Paul Robson March 2000');
			WriteLn;
			Halt(0);
		end;

	VideoInitialise;
	Room.Init;
	Room.Load(x);
	Str(Room.RoomID,s);
	s := Concat('ADK Editor - Room ',s);
	VideoSetTitle(s);
    New(GD,Init);
	GD^.CopyIn(Room);
	GD^.Paint;
	while not VideoGetClick(x,y) do
		begin
			Action := GD^.Click(x,y);
			if Action = 10 then
				begin
					New(pEdit,Init(Room.Message));
                    x := pEdit^.Select(100,100);
					Room.Message := Copy(pEdit^.Text,1,255-106);
					Dispose(pEdit,Done);
				end;
			if (Action > 0) and (Action < 10) then
				begin
					GD^.Extract(Room);
					Room.Save;
					x := Room.Exit[Action-1];
					if x > 0 then
						begin
							Room.Init;
							Room.Load(x);
							GD^.CopyIn(Room);
							GD^.Paint;
							Str(Room.RoomID,s);
							s := Concat('ADK Editor - Room ',s);
							VideoSetTitle(s);
						end;
				end;
		end;

	GD^.Extract(Room);
	Room.Save;
	Dispose(GD,Done);
	VideoDone;
end.
